#include <stdio.h>  // printf, scanf
#define L 3
#define C 3

int main()
{
    // variveis do tipo contador (usadas para percorrer os elementos da matriz)
    int i, j;

    // variveis que armzenam o tamanho da matriz
    int linhas, colunas;

    // varivel que armazena o determinante da matriz
    int determinante, dp, ds;

    // declarao da matriz quadrada de ordem 3
    int M[L][C];

    // declarao da matriz 3 x 5 (Regra de Sarrus)
    int Ms[L][C+2];

    // l os dados da matriz e armazena os mesmos em suas respectivas posies
    for(i=0; i<L; i++)
    {
        for(j=0; j<C; j++)
        {
            printf("Informe o elemento da matriz M da linha %i e coluna %i: ", i, j);
            scanf("%d%*c", &M[i][j]);
        }
    }

    printf("\n****** Elementos da Matriz M ******\n\n");

    // mostra os elementos da matriz na tela
    for(i=0; i<L; i++)
    {
        for(j=0; j<C; j++)
        {
            printf("[%2d] ", M[i][j]);
        }

        // a cada linha da matriz pula uma linha na tela
        printf("\n");
    }

    // aplica a regra de Sarrus para gerar a nova matriz para poder calcular o determinante
    for(i=0; i<L; i++)
    {
        for(j=0; j<C; j++)
        {
            Ms[i][j] = M[i][j];

            if(j == 0)
                Ms[i][3] = M[i][j];

            if(j == 1)
                Ms[i][4] = M[i][j];
        }
    }

    printf("\n****** Elementos da Matriz M (Regra de Sarrus) ******\n\n");

    // mostra os elementos da matriz na tela
    for(i=0; i<L; i++)
    {
        for(j=0; j<C+2; j++)
        {
            printf("[%2d] ", Ms[i][j]);
        }

        // a cada linha da matriz pula uma linha na tela
        printf("\n");
    }

    // calcula e mostra o determinante da matriz 3x3
    dp = (Ms[0][0] * Ms[1][1] * Ms[2][2]) + (Ms[0][1] * Ms[1][2] * Ms[2][3]) + (Ms[0][2] * Ms[1][3] * Ms[2][4]);
    ds = (Ms[0][2] * Ms[1][1] * Ms[2][0]) + (Ms[0][3] * Ms[1][2] * Ms[2][1]) + (Ms[0][4] * Ms[1][3] * Ms[2][2]);

    determinante = dp - ds;

    printf("\nDeterminante da matriz M: %i.\n", determinante);

    return 0;
}
