/*
    Esse programa mostra as diversas formas de declarao
    e utilizao de matrizes em linguagem C.
*/

#include <stdio.h>  // funes scanf e printf

int main()
{
    // declarao de matrizes
    int Mi[2][3] = {{1, 2, 3}, {4, 5, 6}};      // matriz de nmeros inteiros com tamanho definido
    float Mf[2][2] = {{1.5, 2.8}, {3.0, 0.5}};  // matriz de nmeros reais com tamanho definido
    char Mc[3][2];                              // matriz de caracteres com tamanho definido

    // atribuio de alguns valores para as matrizes
    Mc[0][0] = 'D'; // Elemento da 1 linha e 1 coluna da matriz
    Mc[1][1] = 'A'; // Elemento da 2 linha e 2 coluna da matriz
    Mc[2][1] = 'N'; // Elemento da 3 linha e 2 coluna da matriz

    // exibio de alguns elementos das matrizes
    printf("Mi[0][0] = %i\n", Mi[0][0]);
    printf("Mi[1][2] = %i\n", Mi[1][2]);
    printf("Mf[1][1] = %.2f\n", Mf[1][1]);
    printf("Mf[1][0] = %.2f\n", Mf[1][0]);
    printf("Mc[0][0] = %c\n", Mc[0][0]);
    printf("Mc[0][1] = %c\n", Mc[0][1]);
    printf("Mc[5][5] = %c\n", Mc[5][5]);    // ERRADO! CUIDADO!

    return 0;
}
